game
.
 ; 

.L00 ;  rem ******************************************

.L01 ;  rem * Combat DX - 9/22/07 :::::::::::::::::::* 

.L02 ;  rem ******************************************

.L03 ;  rem * Created by Dragnerok X & SeaGtGruff :::*

.L04 ;  rem ******************************************

.L05 ;  rem * Version 0.63 (i.e. demo 6 revision 3)  *

.L06 ;  rem *========================================*

.L07 ;  rem * Free Variables:                        *

.L08 ;  rem *----------------------------------------*

.L09 ;  rem * Q - ({0} - {4}) , ({6} - {7})          *

.L010 ;  rem * R - ({4} - {7})                        *

.L011 ;  rem ******************************************

.L012 ;  rem * Current Variable Usage:                *

.L013 ;  rem *----------------------------------------*

.L014 ;  rem * A - player0 rotation                   *

.L015 ;  rem * B - timer (15 position)                *

.L016 ;  rem * C - timer (6 position)                 *

.L017 ;  rem * D - timer (2 position)                 *

.L018 ;  rem * E - {0} - player0 moves foward switch  * 

.L019 ;  rem *     {1} - player1 moves foward switch  *

.L020 ;  rem *     {2} - intial playfield jump2ready  *

.L021 ;  rem *     {3} - score display stall          *

.L022 ;  rem *     {4} - hides score after stall      *

.L023 ;  rem *     {5} - switchreset on               *

.L024 ;  rem *     {6} - player0 flip bug-fix         *

.L025 ;  rem *     {7} - player1 flip bug-fix         *

.L026 ;  rem * F - player0 foward/reverse detect      *

.L027 ;  rem * G - player1 rotation                   *

.L028 ;  rem * H - theme selection counter            *

.L029 ;  rem * I - player1 foward/reverse detect      *

.L030 ;  rem * J - {0} - joystick0 left               *

.L031 ;  rem *     {1} - joystick0 right              *

.L032 ;  rem *     {2} - joystick0 up                 *

.L033 ;  rem *     {3} - joystick0 down               * 

.L034 ;  rem *     {4} - joystick1 left               *

.L035 ;  rem *     {5} - joystick1 right              *

.L036 ;  rem *     {6} - joystick1 up                 *

.L037 ;  rem *     {7} - joystick1 down               * 

.L038 ;  rem * K - player/missile0x collision buffer  * 

.L039 ;  rem * L - player/missile0y collision buffer  *

.L040 ;  rem * M - player/missile1x collision buffer  *

.L041 ;  rem * N - player/missile1y collision buffer  *

.L042 ;  rem * O - player0 rotation collision buffer  *

.L043 ;  rem * P - player1 rotation collision buffer  *

.L044 ;  rem * Q - {0} - N/A                          *

.L045 ;  rem *     {1} - N/A                          *

.L046 ;  rem *     {2} - N/A                          *

.L047 ;  rem *     {3} - N/A                          *

.L048 ;  rem *     {4} - N/A                          *

.L049 ;  rem *     {5} - switchselect on              *

.L050 ;  rem *     {6} - N/A                          *

.L051 ;  rem *     {7} - N/A                          *

.L052 ;  rem * R - {0} - joystick0 fire               *

.L053 ;  rem *     {1} - joystick1 fire               *

.L054 ;  rem *     {2} - jump back theme 2hidescore   *

.L055 ;  rem *     {3} - further hides score:see e{4} *

.L056 ;  rem *     {4} - N/A                          *

.L057 ;  rem *     {5} - N/A                          *

.L058 ;  rem *     {6} - N/A                          *

.L059 ;  rem *     {7} - N/A                          *

.L060 ;  rem * S - volume fade (experimental)         *

.L061 ;  rem * T - verify (player0) rotation b4 fire  *

.L062 ;  rem * U - verify (player1) rotation b4 fire  *

.L063 ;  rem * V - missile0 movement direction        *

.L064 ;  rem * W - missile1 movement direction        *

.L065 ;  rem * X - missile1 kill detect / sequence    *

.L066 ;  rem * Y - missile0 kill detect / sequence    *

.L067 ;  rem * Z - playfield selection counter        *

.L068 ;  rem ****************************************** 

.L069 ;  rem * Label Translation Guide:               *

.L070 ;  rem *----------------------------------------*

.L071 ;  rem * Fow - foward                           *

.L072 ;  rem * Jmp - jump (i.e. goto statement)       *

.L073 ;  rem * Joy - joystick                         *

.L074 ;  rem * Mov - movement                         *

.L075 ;  rem * P0, P1 - player 0, player 1            *

.L076 ;  rem * Rand - randomization                   *

.L077 ;  rem * Res - reset                            *

.L078 ;  rem * Rev - reverse                          *

.L079 ;  rem * Rot - rotation                         *

.L080 ;  rem * Sel - select                           *

.L081 ;  rem ******************************************

.
 ; 

.L082 ;  rem **********

.L083 ;  rem * Bank 1 *

.L084 ;  rem **********

.
 ; 

.L085 ;  rem *****************************************************

.L086 ;  rem * Bank Summary:                                     *   

.L087 ;  rem *===================================================*

.L088 ;  rem * This bank is pretty much the "highway system" of  * 

.L089 ;  rem * this program. Not only does it tell things when   *

.L090 ;  rem * to start and end, it also directs things to other *

.L091 ;  rem * banks where routines and data can be found. So    *

.L092 ;  rem * too does it set the program up for what can be    *

.L093 ;  rem * found in other banks by defining variables,       *

.L094 ;  rem * setting initial values and also drawing the       *

.L095 ;  rem * screen when everything is set and ready to go.    *                             

.L096 ;  rem *****************************************************

.
 ; 

.L097 ;  include div_mul.asm

.
 ; 

.L098 ;  set romsize 16k

.
 ; 

.L099 ;  dim tank_x  =  var44

.L0100 ;  dim tank_y  =  var45

.L0101 ;  dim x_y  =  var46

.L0102 ;  dim tank_direction  =  var47

.
 ; 

.L0103 ;  h  =  1  :  z  =  1  :  e{2}  =  1

	LDA #1
	STA h
	STA z
	LDA e
	ORA #4
	STA e
.
 ; 

.L0104 ;  score  =  1001

	LDA #$01
	STA score+2
	LDA #$10
	STA score+1
	LDA #$00
	STA score
.
 ; 

.L0105 ;  player0height  =  8  :  player1height  =  8

	LDA #8
	STA player0height
	STA player1height
.
 ; 

.L0106 ;  asm

   LDA #>tank_N

   STA player0pointerhi

   STA player1pointerhi

.
 ; 

.L0107 ;  goto Level_1 bank3

 sta temp7
 lda #>(.Level_1-1)
 pha
 lda #<(.Level_1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
.
 ; 

.Ready
 ; Ready

.
 ; 

.L0108 ;  e{2}  =  0

	LDA e
	AND #251
	STA e
.
 ; 

.L0109 ;  goto Traditional bank3

 sta temp7
 lda #>(.Traditional-1)
 pha
 lda #<(.Traditional-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
.
 ; 

.Start
 ; Start

.
 ; 

.L0110 ;  b  =  1  :  c  =  1  :  d  =  1

	LDA #1
	STA b
	STA c
	STA d
.L0111 ;  s  =  15

	LDA #15
	STA s
.switch_check
 ; switch_check

.L0112 ;  if !switchreset then goto score_off0

 lda #1
 bit SWCHB
	BEQ .skipL0112
.condpart0
 jmp .score_off0

.skipL0112
.
 ; 

.L0113 ;  e{2}  =  1

	LDA e
	ORA #4
	STA e
.L0114 ;  e{3}  =  0  :  r{3}  =  0  :  e{4}  =  0  :  scorecolor  =  0

	LDA e
	AND #247
	STA e
	LDA r
	AND #247
	STA r
	LDA e
	AND #239
	STA e
	LDA #0
	STA scorecolor
.score_off0
 ; score_off0

.L0115 ;  if !switchselect then goto score_off1

 lda #2
 bit SWCHB
	BEQ .skipL0115
.condpart1
 jmp .score_off1

.skipL0115
.L0116 ;  e{2}  =  1

	LDA e
	ORA #4
	STA e
.L0117 ;  e{0}  =  0  :  e{1}  =  0  :  e{3}  =  0  :  r{3}  =  0  :  e{4}  =  0  :  f  =  0  :  i  =  0  :  scorecolor  =  0

	LDA e
	AND #254
	STA e
	LDA e
	AND #253
	STA e
	LDA e
	AND #247
	STA e
	LDA r
	AND #247
	STA r
	LDA e
	AND #239
	STA e
	LDA #0
	STA f
	STA i
	STA scorecolor
.score_off1
 ; score_off1

.L0118 ;  if switchselect  ||  switchreset then goto no_blink

 lda #2
 bit SWCHB
	BNE .skipL0118
.condpart2
 jmp .condpart3
.skipL0118
 lda #1
 bit SWCHB
	BNE .skip0OR
.condpart3
 jmp .no_blink

.skip0OR
.L0119 ;  if e{2}  &&  b  =  15 then e{3}  =  1

	LDA e
	AND #4
	BEQ .skipL0119
.condpart4
	LDA b
	CMP #15
     BNE .skip4then
.condpart5
	LDA e
	ORA #8
	STA e
.skip4then
.skipL0119
.L0120 ;  if e{3}  &&  b  =  14 then r{3}  =  1

	LDA e
	AND #8
	BEQ .skipL0120
.condpart6
	LDA b
	CMP #14
     BNE .skip6then
.condpart7
	LDA r
	ORA #8
	STA r
.skip6then
.skipL0120
.L0121 ;  if r{3}  &&  b  =  13 then e{4}  =  1

	LDA r
	AND #8
	BEQ .skipL0121
.condpart8
	LDA b
	CMP #13
     BNE .skip8then
.condpart9
	LDA e
	ORA #16
	STA e
.skip8then
.skipL0121
.L0122 ;  r{2}  =  1

	LDA r
	ORA #4
	STA r
.L0123 ;  if e{4}  &&  b  =  12 then goto Traditional bank3

	LDA e
	AND #16
	BEQ .skipL0123
.condpart10
	LDA b
	CMP #12
     BNE .skip10then
.condpart11
 sta temp7
 lda #>(.Traditional-1)
 pha
 lda #<(.Traditional-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
.skip10then
.skipL0123
.L0124 ;  r{2}  =  0

	LDA r
	AND #251
	STA r
.no_blink
 ; no_blink

.L0125 ;  COLUP0  =  68

	LDA #68
	STA COLUP0
.L0126 ;  COLUP1  =  132

	LDA #132
	STA COLUP1
.
 ; 

.L0127 ;  rem **************************************

.L0128 ;  rem * Sound Code Slot                    *

.L0129 ;  rem *====================================*

.L0130 ;  rem * This area up to the skip_sound     *

.L0131 ;  rem * label is entirely directed towards *

.L0132 ;  rem * the sound used in this game and    *

.L0133 ;  rem * is the only place where such code  *

.L0134 ;  rem * can be found. Basically, how this  *

.L0135 ;  rem * works, is it constantly scans for  *

.L0136 ;  rem * any button presses (up, fire, etc) *

.L0137 ;  rem * and if found directs it to the     *

.L0138 ;  rem * specific routine used to generate  *

.L0139 ;  rem * whatever sound is desired. Also    *

.L0140 ;  rem * note that to achieve some desired  *

.L0141 ;  rem * sounds i've been relying on timers *

.L0142 ;  rem * along with the "s" variable acting *

.L0143 ;  rem * as a kind of "volume fader". I     *

.L0144 ;  rem * think this is why the sounds bec-  *

.L0145 ;  rem * -ome distorted over time, however, *

.L0146 ;  rem * further research may be necessary. *

.L0147 ;  rem * What I'm aiming for, sound-wise,   *

.L0148 ;  rem * though is something pretty close   *

.L0149 ;  rem * to Combat's original sound-track,  *

.L0150 ;  rem * but if it can be made a bit clear- *

.L0151 ;  rem * er, as I have demonstrated in      *

.L0152 ;  rem * earlier sound demos, by all means, *

.L0153 ;  rem * go for it; change is good.         *

.L0154 ;  rem **************************************

.
 ; 

.L0155 ;  if s  =  0  &&  x  =  0  &&  y  =  0  &&  !r{0}  &&  !r{1} then s  =  15

	LDA s
	CMP #0
     BNE .skipL0155
.condpart12
	LDA x
	CMP #0
     BNE .skip12then
.condpart13
	LDA y
	CMP #0
     BNE .skip13then
.condpart14
	LDA r
	LSR
	BCS .skip14then
.condpart15
	LDA r
	AND #2
	BNE .skip15then
.condpart16
	LDA #15
	STA s
.skip15then
.skip14then
.skip13then
.skip12then
.skipL0155
.L0156 ;  if s  =  0 then goto skip_firesound

	LDA s
	CMP #0
     BNE .skipL0156
.condpart17
 jmp .skip_firesound

.skipL0156
.L0157 ;  if e{5}  ||  q{5} then AUDV0  =  0  :  AUDV1  =  0  :  goto skip_sound

	LDA e
	AND #32
	BEQ .skipL0157
.condpart18
 jmp .condpart19
.skipL0157
	LDA q
	AND #32
	BEQ .skip9OR
.condpart19
	LDA #0
	STA AUDV0
	STA AUDV1
 jmp .skip_sound

.skip9OR
.L0158 ;  if x  >  0  &&  d  =  1 then s  =  s  -  1

	LDA #0
	CMP x
     BCS .skipL0158
.condpart20
	LDA d
	CMP #1
     BNE .skip20then
.condpart21
	DEC s
.skip20then
.skipL0158
.L0159 ;  if y  >  0  &&  d  =  1 then s  =  s  -  1

	LDA #0
	CMP y
     BCS .skipL0159
.condpart22
	LDA d
	CMP #1
     BNE .skip22then
.condpart23
	DEC s
.skip22then
.skipL0159
.L0160 ;  if x  >  0  ||  y  >  0 then AUDC0  =  8  :  AUDF0  =  15  :  AUDV0  =  s

	LDA #0
	CMP x
     BCS .skipL0160
.condpart24
 jmp .condpart25
.skipL0160
	LDA #0
	CMP y
     BCS .skip12OR
.condpart25
	LDA #8
	STA AUDC0
	LDA #15
	STA AUDF0
	LDA s
	STA AUDV0
.skip12OR
.L0161 ;  if x  >  0  ||  y  >  0 then AUDC1  =  8  :  AUDF1  =  15  :  AUDV1  =  s  :  goto skip_sound

	LDA #0
	CMP x
     BCS .skipL0161
.condpart26
 jmp .condpart27
.skipL0161
	LDA #0
	CMP y
     BCS .skip13OR
.condpart27
	LDA #8
	STA AUDC1
	LDA #15
	STA AUDF1
	LDA s
	STA AUDV1
 jmp .skip_sound

.skip13OR
.L0162 ;  if r{0}  &&  d  =  1 then s  =  s  -  1

	LDA r
	LSR
	BCC .skipL0162
.condpart28
	LDA d
	CMP #1
     BNE .skip28then
.condpart29
	DEC s
.skip28then
.skipL0162
.L0163 ;  if r{1}  &&  d  =  1 then s  =  s  -  1

	LDA r
	AND #2
	BEQ .skipL0163
.condpart30
	LDA d
	CMP #1
     BNE .skip30then
.condpart31
	DEC s
.skip30then
.skipL0163
.L0164 ;  if r{0}  ||  r{1} then AUDC0  =  8  :  AUDF0  =  15  :  AUDV0  =  s

	LDA r
	LSR
	BCC .skipL0164
.condpart32
 jmp .condpart33
.skipL0164
	LDA r
	AND #2
	BEQ .skip16OR
.condpart33
	LDA #8
	STA AUDC0
	LDA #15
	STA AUDF0
	LDA s
	STA AUDV0
.skip16OR
.L0165 ;  if r{0}  ||  r{1} then AUDC1  =  8  :  AUDF1  =  15  :  AUDV1  =  s  :  goto skip_sound

	LDA r
	LSR
	BCC .skipL0165
.condpart34
 jmp .condpart35
.skipL0165
	LDA r
	AND #2
	BEQ .skip17OR
.condpart35
	LDA #8
	STA AUDC1
	LDA #15
	STA AUDF1
	LDA s
	STA AUDV1
 jmp .skip_sound

.skip17OR
.skip_firesound
 ; skip_firesound

.L0166 ;  if j{2}  ||  j{6} then AUDC0  =  2  :  AUDF0  =  5  :  AUDV0  =  8

	LDA j
	AND #4
	BEQ .skipL0166
.condpart36
 jmp .condpart37
.skipL0166
	BIT j
	BVC .skip18OR
.condpart37
	LDA #2
	STA AUDC0
	LDA #5
	STA AUDF0
	LDA #8
	STA AUDV0
.skip18OR
.L0167 ;  if j{2}  ||  j{6} then AUDC1  =  2  :  AUDF1  =  5  :  AUDV1  =  8  :  goto skip_sound

	LDA j
	AND #4
	BEQ .skipL0167
.condpart38
 jmp .condpart39
.skipL0167
	BIT j
	BVC .skip19OR
.condpart39
	LDA #2
	STA AUDC1
	LDA #5
	STA AUDF1
	LDA #8
	STA AUDV1
 jmp .skip_sound

.skip19OR
.L0168 ;  if j{3}  ||  j{7} then AUDC0  =  2  :  AUDF0  =  4  :  AUDV0  =  8

	LDA j
	AND #8
	BEQ .skipL0168
.condpart40
 jmp .condpart41
.skipL0168
	BIT j
	BPL .skip20OR
.condpart41
	LDA #2
	STA AUDC0
	LDA #4
	STA AUDF0
	LDA #8
	STA AUDV0
.skip20OR
.L0169 ;  if j{3}  ||  j{7} then AUDC1  =  2  :  AUDF1  =  4  :  AUDV1  =  8  :  goto skip_sound

	LDA j
	AND #8
	BEQ .skipL0169
.condpart42
 jmp .condpart43
.skipL0169
	BIT j
	BPL .skip21OR
.condpart43
	LDA #2
	STA AUDC1
	LDA #4
	STA AUDF1
	LDA #8
	STA AUDV1
 jmp .skip_sound

.skip21OR
.L0170 ;  AUDC0  =  2  :  AUDC1  =  2

	LDA #2
	STA AUDC0
	STA AUDC1
.L0171 ;  AUDF0  =  13  :  AUDF1  =  13

	LDA #13
	STA AUDF0
	STA AUDF1
.L0172 ;  AUDV0  =  5  :  AUDV1  =  5

	LDA #5
	STA AUDV0
	STA AUDV1
.skip_sound
 ; skip_sound

.L0173 ;  b  =  b  +  1

	INC b
.L0174 ;  if b  =  16 then b  =  0

	LDA b
	CMP #16
     BNE .skipL0174
.condpart44
	LDA #0
	STA b
.skipL0174
.L0175 ;  c  =  c  +  1

	INC c
.L0176 ;  if c  =  7 then c  =  0

	LDA c
	CMP #7
     BNE .skipL0176
.condpart45
	LDA #0
	STA c
.skipL0176
.L0177 ;  d  =  d  +  1

	INC d
.L0178 ;  if d  =  2 then d  =  0

	LDA d
	CMP #2
     BNE .skipL0178
.condpart46
	LDA #0
	STA d
.skipL0178
.L0179 ;  if c  =  6 then goto clear0

	LDA c
	CMP #6
     BNE .skipL0179
.condpart47
 jmp .clear0

.skipL0179
.L0180 ;  if collision(player0,playfield) then goto skip_clear0

	BIT CXP0FB
	BPL .skipL0180
.condpart48
 jmp .skip_clear0

.skipL0180
.clear0
 ; clear0

.L0181 ;  k  =  0  :  l  =  0

	LDA #0
	STA k
	STA l
.skip_clear0
 ; skip_clear0

.L0182 ;  if c  =  6 then goto clear1

	LDA c
	CMP #6
     BNE .skipL0182
.condpart49
 jmp .clear1

.skipL0182
.L0183 ;  if collision(player1,playfield) then goto skip_clear1

	BIT CXP1FB
	BPL .skipL0183
.condpart50
 jmp .skip_clear1

.skipL0183
.clear1
 ; clear1

.L0184 ;  m  =  0  :  n  =  0

	LDA #0
	STA m
	STA n
.skip_clear1
 ; skip_clear1

.L0185 ;  o  =  0  :  p  =  0

	LDA #0
	STA o
	STA p
.L0186 ;  if x  >=  1 then goto joy_redir0

	LDA x
	CMP #1
     BCC .skipL0186
.condpart51
 jmp .joy_redir0

.skipL0186
.L0187 ;  if e{5} then goto skip_res

	LDA e
	AND #32
	BEQ .skipL0187
.condpart52
 jmp .skip_res

.skipL0187
.L0188 ;  if switchreset then e{5}  =  1

 lda #1
 bit SWCHB
	BNE .skipL0188
.condpart53
	LDA e
	ORA #32
	STA e
.skipL0188
.L0189 ;  if switchreset then h  =  h  +  1  :  score  =  score  +  1000

 lda #1
 bit SWCHB
	BNE .skipL0189
.condpart54
	INC h
	SED
	CLC
	LDA score+1
	ADC #$10
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
.skipL0189
.L0190 ;  if switchreset  &&  h  =  4 then h  =  1  :  score  =  score  -  3000

 lda #1
 bit SWCHB
	BNE .skipL0190
.condpart55
	LDA h
	CMP #4
     BNE .skip55then
.condpart56
	LDA #1
	STA h
	SED
	SEC
	LDA score+2
	SBC #$00
	STA score+2
	LDA score+1
	SBC #$30
	STA score+1
	LDA score
	SBC #$00
	STA score
	CLD
.skip55then
.skipL0190
.L0191 ;  if switchreset then goto Traditional bank3

 lda #1
 bit SWCHB
	BNE .skipL0191
.condpart57
 sta temp7
 lda #>(.Traditional-1)
 pha
 lda #<(.Traditional-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
.skipL0191
.skip_res
 ; skip_res

.L0192 ;  if q{5} then goto skip_sel

	LDA q
	AND #32
	BEQ .skipL0192
.condpart58
 jmp .skip_sel

.skipL0192
.L0193 ;  if switchselect then q{5}  =  1

 lda #2
 bit SWCHB
	BNE .skipL0193
.condpart59
	LDA q
	ORA #32
	STA q
.skipL0193
.L0194 ;  if switchselect then z  =  z  +  1  :  score  =  score  +  1

 lda #2
 bit SWCHB
	BNE .skipL0194
.condpart60
	INC z
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
.skipL0194
.L0195 ;  if switchselect  &&  z  =  36 then z  =  1  :  score  =  score  -  35

 lda #2
 bit SWCHB
	BNE .skipL0195
.condpart61
	LDA z
	CMP #36
     BNE .skip61then
.condpart62
	LDA #1
	STA z
	SED
	SEC
	LDA score+2
	SBC #$35
	STA score+2
	LDA score+1
	SBC #$00
	STA score+1
	LDA score
	SBC #$00
	STA score
	CLD
.skip61then
.skipL0195
.L0196 ;  if switchselect then goto Level_1 bank3

 lda #2
 bit SWCHB
	BNE .skipL0196
.condpart63
 sta temp7
 lda #>(.Level_1-1)
 pha
 lda #<(.Level_1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #3
 jmp BS_jsr
.skipL0196
.skip_sel
 ; skip_sel

.L0197 ;  if !switchreset then e{5}  =  0

 lda #1
 bit SWCHB
	BEQ .skipL0197
.condpart64
	LDA e
	AND #223
	STA e
.skipL0197
.L0198 ;  if !switchselect then q{5}  =  0

 lda #2
 bit SWCHB
	BEQ .skipL0198
.condpart65
	LDA q
	AND #223
	STA q
.skipL0198
.L0199 ;  if !switchleftb then goto AIp0 bank2

 bit SWCHB
	BVC .skipL0199
.condpart66
 sta temp7
 lda #>(.AIp0-1)
 pha
 lda #<(.AIp0-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skipL0199
.L0200 ;  goto noAIp0 bank2

 sta temp7
 lda #>(.noAIp0-1)
 pha
 lda #<(.noAIp0-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.joy_redir0
 ; joy_redir0

.L0201 ;  if y  >=  1 then goto joy_redir1

	LDA y
	CMP #1
     BCC .skipL0201
.condpart67
 jmp .joy_redir1

.skipL0201
.L0202 ;  if !switchrightb then goto AIp1 bank2

 bit SWCHB
	BPL .skipL0202
.condpart68
 sta temp7
 lda #>(.AIp1-1)
 pha
 lda #<(.AIp1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skipL0202
.L0203 ;  goto noAIp1 bank2

 sta temp7
 lda #>(.noAIp1-1)
 pha
 lda #<(.noAIp1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.joy_redir1
 ; joy_redir1

.L0204 ;  if b  <>  15 then goto skip_rotatebuffer

	LDA b
	CMP #15
     BEQ .skipL0204
.condpart69
 jmp .skip_rotatebuffer

.skipL0204
.L0205 ;  if j{0}  &&  !collision(player0,playfield) then o  =  o  +  1

	LDA j
	LSR
	BCC .skipL0205
.condpart70
	BIT CXP0FB
	BMI .skip70then
.condpart71
	INC o
.skip70then
.skipL0205
.L0206 ;  if j{1}  &&  !collision(player0,playfield) then o  =  o  +  15

	LDA j
	AND #2
	BEQ .skipL0206
.condpart72
	BIT CXP0FB
	BMI .skip72then
.condpart73
	LDA o
	CLC
	ADC #15
	STA o
.skip72then
.skipL0206
.L0207 ;  if j{4}  &&  !collision(player1,playfield) then p  =  p  +  1

	LDA j
	AND #16
	BEQ .skipL0207
.condpart74
	BIT CXP1FB
	BMI .skip74then
.condpart75
	INC p
.skip74then
.skipL0207
.L0208 ;  if j{5}  &&  !collision(player1,playfield) then p  =  p  +  15

	LDA j
	AND #32
	BEQ .skipL0208
.condpart76
	BIT CXP1FB
	BMI .skip76then
.condpart77
	LDA p
	CLC
	ADC #15
	STA p
.skip76then
.skipL0208
.L0209 ;  a  =  a  +  o

	LDA a
	CLC
	ADC o
	STA a
.L0210 ;  g  =  g  +  p

	LDA g
	CLC
	ADC p
	STA g
.skip_rotatebuffer
 ; skip_rotatebuffer

.L0211 ;  gosub check_a

 jsr .check_a

.L0212 ;  gosub check_g

 jsr .check_g

.L0213 ;  if c  <>  6 then goto skip_borderbuffer

	LDA c
	CMP #6
     BEQ .skipL0213
.condpart78
 jmp .skip_borderbuffer

.skipL0213
.L0214 ;  if player0x  <  2 then k  =  1  :  goto p1movjmprev

	LDA player0x
	CMP #2
     BCS .skipL0214
.condpart79
	LDA #1
	STA k
 jmp .p1movjmprev

.skipL0214
.L0215 ;  if player0x  >  152 then k  =  255  :  goto p1movjmprev

	LDA #152
	CMP player0x
     BCS .skipL0215
.condpart80
	LDA #255
	STA k
 jmp .p1movjmprev

.skipL0215
.L0216 ;  if player1x  <  2 then m  =  1  :  goto p1movjmprev

	LDA player1x
	CMP #2
     BCS .skipL0216
.condpart81
	LDA #1
	STA m
 jmp .p1movjmprev

.skipL0216
.L0217 ;  if player1x  >  152 then m  =  255  :  goto p1movjmprev

	LDA #152
	CMP player1x
     BCS .skipL0217
.condpart82
	LDA #255
	STA m
 jmp .p1movjmprev

.skipL0217
.L0218 ;  if player0y  <  8 then l  =  1  : goto p1movjmprev

	LDA player0y
	CMP #8
     BCS .skipL0218
.condpart83
	LDA #1
	STA l
 jmp .p1movjmprev

.skipL0218
.L0219 ;  if player0y  >  88 then l  =  255  :  goto p1movjmprev

	LDA #88
	CMP player0y
     BCS .skipL0219
.condpart84
	LDA #255
	STA l
 jmp .p1movjmprev

.skipL0219
.L0220 ;  if player1y  <  8 then n  =  1  :  goto p1movjmprev

	LDA player1y
	CMP #8
     BCS .skipL0220
.condpart85
	LDA #1
	STA n
 jmp .p1movjmprev

.skipL0220
.L0221 ;  if player1y  >  88 then n  =  255  :  goto p1movjmprev

	LDA #88
	CMP player1y
     BCS .skipL0221
.condpart86
	LDA #255
	STA n
 jmp .p1movjmprev

.skipL0221
.skip_borderbuffer
 ; skip_borderbuffer

.L0222 ;  if j{2}  &&  f  =  1 then goto p0fowset bank2

	LDA j
	AND #4
	BEQ .skipL0222
.condpart87
	LDA f
	CMP #1
     BNE .skip87then
.condpart88
 sta temp7
 lda #>(.p0fowset-1)
 pha
 lda #<(.p0fowset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip87then
.skipL0222
.p0fowjmp
 ; p0fowjmp

.L0223 ;  if j{6}  &&  i  =  1 then goto p1fowset bank2

	BIT j
	BVC .skipL0223
.condpart89
	LDA i
	CMP #1
     BNE .skip89then
.condpart90
 sta temp7
 lda #>(.p1fowset-1)
 pha
 lda #<(.p1fowset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip89then
.skipL0223
.p1fowjmp
 ; p1fowjmp

.L0224 ;  if j{3}  &&  f  =  0 then goto p0revset bank2

	LDA j
	AND #8
	BEQ .skipL0224
.condpart91
	LDA f
	CMP #0
     BNE .skip91then
.condpart92
 sta temp7
 lda #>(.p0revset-1)
 pha
 lda #<(.p0revset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip91then
.skipL0224
.p0revjmp
 ; p0revjmp

.L0225 ;  if j{7}  &&  i  =  0 then goto p1revset bank2

	BIT j
	BPL .skipL0225
.condpart93
	LDA i
	CMP #0
     BNE .skip93then
.condpart94
 sta temp7
 lda #>(.p1revset-1)
 pha
 lda #<(.p1revset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip93then
.skipL0225
.p1revjmp
 ; p1revjmp

.L0226 ;  if j{2}  &&  !e{0} then goto p0movset bank2

	LDA j
	AND #4
	BEQ .skipL0226
.condpart95
	LDA e
	LSR
	BCS .skip95then
.condpart96
 sta temp7
 lda #>(.p0movset-1)
 pha
 lda #<(.p0movset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip95then
.skipL0226
.p0movjmpfow
 ; p0movjmpfow

.L0227 ;  if j{6}  &&  !e{1} then goto p1movset bank2

	BIT j
	BVC .skipL0227
.condpart97
	LDA e
	AND #2
	BNE .skip97then
.condpart98
 sta temp7
 lda #>(.p1movset-1)
 pha
 lda #<(.p1movset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip97then
.skipL0227
.p1movjmpfow
 ; p1movjmpfow

.L0228 ;  if j{3}  &&  e{0} then goto p0movset bank2

	LDA j
	AND #8
	BEQ .skipL0228
.condpart99
	LDA e
	LSR
	BCC .skip99then
.condpart100
 sta temp7
 lda #>(.p0movset-1)
 pha
 lda #<(.p0movset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip99then
.skipL0228
.p0movjmprev
 ; p0movjmprev

.L0229 ;  if j{7}  &&  e{1} then goto p1movset bank2

	BIT j
	BPL .skipL0229
.condpart101
	LDA e
	AND #2
	BEQ .skip101then
.condpart102
 sta temp7
 lda #>(.p1movset-1)
 pha
 lda #<(.p1movset-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
.skip101then
.skipL0229
.p1movjmprev
 ; p1movjmprev

.L0230 ;  gosub check_missile0 bank2

 sta temp7
 lda #>(ret_point1-1)
 pha
 lda #<(ret_point1-1)
 pha
 lda #>(.check_missile0-1)
 pha
 lda #<(.check_missile0-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
ret_point1
.L0231 ;  gosub check_missile1 bank2

 sta temp7
 lda #>(ret_point2-1)
 pha
 lda #<(ret_point2-1)
 pha
 lda #>(.check_missile1-1)
 pha
 lda #<(.check_missile1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
ret_point2
.L0232 ;  if !collision(player0,player1) then goto pushdetect_y

	BIT CXPPMM
	BMI .skipL0232
.condpart103
 jmp .pushdetect_y

.skipL0232
.L0233 ;  if collision(player0,player1) then goto pf_check0

	BIT CXPPMM
	BPL .skipL0233
.condpart104
 jmp .pf_check0

.skipL0233
.pf_check0
 ; pf_check0

.L0234 ;  if collision(player0,playfield) then goto pushdetect_y

	BIT CXP0FB
	BPL .skipL0234
.condpart105
 jmp .pushdetect_y

.skipL0234
.pf_check1
 ; pf_check1

.L0235 ;  if collision(player1,playfield) then goto pushdetect_y

	BIT CXP1FB
	BPL .skipL0235
.condpart106
 jmp .pushdetect_y

.skipL0235
.L0236 ;  if c  <>  6 then goto pushdetect_y

	LDA c
	CMP #6
     BEQ .skipL0236
.condpart107
 jmp .pushdetect_y

.skipL0236
.L0237 ;  if x  >  1  ||  y  >  1 then goto pushdetect_y

	LDA #1
	CMP x
     BCS .skipL0237
.condpart108
 jmp .condpart109
.skipL0237
	LDA #1
	CMP y
     BCS .skip36OR
.condpart109
 jmp .pushdetect_y

.skip36OR
.L0238 ;  if player0x  >  player1x then k  =  1  :  m  =  255  :  goto pushdetect_x

	LDA player1x
	CMP player0x
     BCS .skipL0238
.condpart110
	LDA #1
	STA k
	LDA #255
	STA m
 jmp .pushdetect_x

.skipL0238
.L0239 ;  if player0x  <  player1x then k  =  255  :  m  =  1

	LDA player0x
	CMP player1x
     BCS .skipL0239
.condpart111
	LDA #255
	STA k
	LDA #1
	STA m
.skipL0239
.pushdetect_x
 ; pushdetect_x

.L0240 ;  if player0y  >  player1y then l  =  1  :  n  =  255  :  goto pushdetect_y

	LDA player1y
	CMP player0y
     BCS .skipL0240
.condpart112
	LDA #1
	STA l
	LDA #255
	STA n
 jmp .pushdetect_y

.skipL0240
.L0241 ;  if player0y  <  player1y then l  =  255  :  n  =  1

	LDA player0y
	CMP player1y
     BCS .skipL0241
.condpart113
	LDA #255
	STA l
	LDA #1
	STA n
.skipL0241
.pushdetect_y
 ; pushdetect_y

.L0242 ;  player0x  =  player0x  +  k

	LDA player0x
	CLC
	ADC k
	STA player0x
.L0243 ;  player0y  =  player0y  +  l

	LDA player0y
	CLC
	ADC l
	STA player0y
.L0244 ;  player1x  =  player1x  +  m

	LDA player1x
	CLC
	ADC m
	STA player1x
.L0245 ;  player1y  =  player1y  +  n

	LDA player1y
	CLC
	ADC n
	STA player1y
.L0246 ;  missile0x  =  missile0x  +  k

	LDA missile0x
	CLC
	ADC k
	STA missile0x
.L0247 ;  missile0y  =  missile0y  +  l

	LDA missile0y
	CLC
	ADC l
	STA missile0y
.L0248 ;  missile1x  =  missile1x  +  m

	LDA missile1x
	CLC
	ADC m
	STA missile1x
.L0249 ;  missile1y  =  missile1y  +  n

	LDA missile1y
	CLC
	ADC n
	STA missile1y
.apply_movement
 ; apply_movement

.L0250 ;  if x  <>  0 then gosub kill_player0 bank2

	LDA x
	CMP #0
     BEQ .skipL0250
.condpart114
 sta temp7
 lda #>(ret_point3-1)
 pha
 lda #<(ret_point3-1)
 pha
 lda #>(.kill_player0-1)
 pha
 lda #<(.kill_player0-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
ret_point3
.skipL0250
.L0251 ;  if y  <>  0 then gosub kill_player1 bank2

	LDA y
	CMP #0
     BEQ .skipL0251
.condpart115
 sta temp7
 lda #>(ret_point4-1)
 pha
 lda #<(ret_point4-1)
 pha
 lda #>(.kill_player1-1)
 pha
 lda #<(.kill_player1-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #2
 jmp BS_jsr
ret_point4
.skipL0251
.L0252 ;  if x  <>  0 then goto skip_killproc0

	LDA x
	CMP #0
     BEQ .skipL0252
.condpart116
 jmp .skip_killproc0

.skipL0252
.L0253 ;  temp1  =  a  -  1

	LDA a
	SEC
	SBC #1
	STA temp1
.L0254 ;  if e{0} then temp1  =  temp1  +  8

	LDA e
	LSR
	BCC .skipL0254
.condpart117
	LDA temp1
	CLC
	ADC #8
	STA temp1
.skipL0254
.L0255 ;  if temp1  >  15 then temp1  =  temp1  -  16

	LDA #15
	CMP temp1
     BCS .skipL0255
.condpart118
	LDA temp1
	SEC
	SBC #16
	STA temp1
.skipL0255
.L0256 ;  player0pointerlo  =  pointerlo[temp1]

	LDX temp1
	LDA pointerlo,x
	STA player0pointerlo
.L0257 ;  REFP0  =  reflect[temp1]

	LDX temp1
	LDA reflect,x
	STA REFP0
.skip_killproc0
 ; skip_killproc0

.L0258 ;  if y  <>  0 then goto skip_killproc1

	LDA y
	CMP #0
     BEQ .skipL0258
.condpart119
 jmp .skip_killproc1

.skipL0258
.L0259 ;  temp1  =  g  -  1

	LDA g
	SEC
	SBC #1
	STA temp1
.L0260 ;  if e{1} then temp1  =  temp1  +  8

	LDA e
	AND #2
	BEQ .skipL0260
.condpart120
	LDA temp1
	CLC
	ADC #8
	STA temp1
.skipL0260
.L0261 ;  if temp1  >  15 then temp1  =  temp1  -  16

	LDA #15
	CMP temp1
     BCS .skipL0261
.condpart121
	LDA temp1
	SEC
	SBC #16
	STA temp1
.skipL0261
.L0262 ;  player1pointerlo  =  pointerlo[temp1]

	LDX temp1
	LDA pointerlo,x
	STA player1pointerlo
.L0263 ;  REFP1  =  reflect[temp1]

	LDX temp1
	LDA reflect,x
	STA REFP1
.skip_killproc1
 ; skip_killproc1

.L0264 ;  drawscreen

 sta temp7
 lda #>(ret_point5-1)
 pha
 lda #<(ret_point5-1)
 pha
 lda #>(drawscreen-1)
 pha
 lda #<(drawscreen-1)
 pha
 lda temp7
 pha
 txa
 pha
 ldx #4
 jmp BS_jsr
ret_point5
.
 ; 

.L0265 ;  if collision(player0,playfield) then a  =  a  -  o  :  gosub check_a

	BIT CXP0FB
	BPL .skipL0265
.condpart122
	LDA a
	SEC
	SBC o
	STA a
 jsr .check_a

.skipL0265
.L0266 ;  if collision(player1,playfield) then g  =  g  -  p  :  gosub check_g

	BIT CXP1FB
	BPL .skipL0266
.condpart123
	LDA g
	SEC
	SBC p
	STA g
 jsr .check_g

.skipL0266
.
 ; 

.L0267 ;  if collision(player0,playfield) then player0x  =  player0x  -  k  :  player0y  =  player0y  -  l

	BIT CXP0FB
	BPL .skipL0267
.condpart124
	LDA player0x
	SEC
	SBC k
	STA player0x
	LDA player0y
	SEC
	SBC l
	STA player0y
.skipL0267
.L0268 ;  if collision(player0,playfield) then missile0x  =  missile0x  -  k  :  missile0y  =  missile0y  -  l

	BIT CXP0FB
	BPL .skipL0268
.condpart125
	LDA missile0x
	SEC
	SBC k
	STA missile0x
	LDA missile0y
	SEC
	SBC l
	STA missile0y
.skipL0268
.L0269 ;  if collision(player1,playfield) then player1x  =  player1x  -  m  :  player1y  =  player1y  -  n

	BIT CXP1FB
	BPL .skipL0269
.condpart126
	LDA player1x
	SEC
	SBC m
	STA player1x
	LDA player1y
	SEC
	SBC n
	STA player1y
.skipL0269
.L0270 ;  if collision(player1,playfield) then missile1x  =  missile1x  -  m  :  missile1y  =  missile1y  -  n

	BIT CXP1FB
	BPL .skipL0270
.condpart127
	LDA missile1x
	SEC
	SBC m
	STA missile1x
	LDA missile1y
	SEC
	SBC n
	STA missile1y
.skipL0270
.
 ; 

.L0271 ;  goto switch_check

 jmp .switch_check

.
 ; 

.check_a
 ; check_a

.L0272 ;  if a  >  240 then a  =  a  +  16

	LDA #240
	CMP a
     BCS .skipL0272
.condpart128
	LDA a
	CLC
	ADC #16
	STA a
.skipL0272
.L0273 ;  if a  >  16 then a  =  a  -  16

	LDA #16
	CMP a
     BCS .skipL0273
.condpart129
	LDA a
	SEC
	SBC #16
	STA a
.skipL0273
.L0274 ;  if a  =  0 then a  =  16

	LDA a
	CMP #0
     BNE .skipL0274
.condpart130
	LDA #16
	STA a
.skipL0274
.L0275 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.check_g
 ; check_g

.L0276 ;  if g  >  240 then g  =  g  +  16

	LDA #240
	CMP g
     BCS .skipL0276
.condpart131
	LDA g
	CLC
	ADC #16
	STA g
.skipL0276
.L0277 ;  if g  >  16 then g  =  g  -  16

	LDA #16
	CMP g
     BCS .skipL0277
.condpart132
	LDA g
	SEC
	SBC #16
	STA g
.skipL0277
.L0278 ;  if g  =  0 then g  =  16

	LDA g
	CMP #0
     BNE .skipL0278
.condpart133
	LDA #16
	STA g
.skipL0278
.L0279 ;  return

	tsx
	lda 2,x ; check return address
	eor #(>*) ; vs. current PCH
	and #$E0 ;  mask off all but top 3 bits
	beq *+5 ; if equal, do normal return
	JMP BS_return
	RTS
.
 ; 

.L0280 ;  data pointerlo

	JMP .skipL0280
pointerlo
	.byte    $24,$1B,$12,$09,$00,$09,$12,$1B,$24,$2D,$36,$3F,$48,$3F,$36,$2D

.skipL0280
